export declare type ReadonlyPartial<T> = Readonly<Partial<T>>;
export declare type ReadonlyRequired<T> = Readonly<Required<T>>;
export declare type ReadonlyPick<T, K extends keyof T> = Readonly<Pick<T, K>>;
export declare type ReadonlyRecord<K extends string | number | symbol, T> = Readonly<Record<K, T>>;
export declare type ReadonlyURLSearchParams = Readonly<Omit<URLSearchParams, "append" | "delete" | "set" | "sort">> & {
    [Symbol.iterator](): IterableIterator<readonly [string, string]>;
};
export declare const ReadonlyURLSearchParams: (init?: string | Record<string, string> | URLSearchParams | string[][] | ReadonlyURLSearchParams | readonly string[][] | undefined) => ReadonlyURLSearchParams;
export declare type ReadonlyURL = Readonly<Omit<URL, "searchParams">> & {
    searchParams: ReadonlyURLSearchParams;
};
export declare const ReadonlyURL: (url: string, base?: string | URL | ReadonlyURL | undefined) => ReadonlyURL | undefined;
export declare type ReadonlyDate = Readonly<Omit<Date, "setTime" | "setMilliseconds" | "setUTCMilliseconds" | "setSeconds" | "setUTCSeconds" | "setMinutes" | "setUTCMinutes" | "setHours" | "setUTCHours" | "setDate" | "setUTCDate" | "setMonth" | "setUTCMonth" | "setFullYear" | "setUTCFullYear">>;
export declare const ReadonlyDate: (value: number | string | Date | ReadonlyDate) => ReadonlyDate;
export declare const ValidReadonlyDate: (value: number | string | Date | ReadonlyDate) => ReadonlyDate | undefined;
export declare type ReadonlyWeakSet<T extends object> = Readonly<Omit<WeakSet<T>, "add" | "delete">>;
export declare type ReadonlyWeakMap<K extends object, V> = Readonly<Omit<WeakMap<K, V>, "delete" | "set">>;
export declare const ReadonlySet: <T>(values: Iterable<T>) => ReadonlySet<T>;
export declare const ReadonlyWeakSet: <T extends object>(values: Iterable<T>) => Readonly<Pick<WeakSet<T>, "has">>;
export declare const ReadonlyMap: <K, V>(values: Iterable<readonly [K, V]>) => ReadonlyMap<K, V>;
export declare const ReadonlyWeakMap: <K extends object, V>(values: Iterable<[K, V]>) => Readonly<Pick<WeakMap<K, V>, "get" | "has">>;
