"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReadonlyWeakMap = exports.ReadonlyMap = exports.ReadonlyWeakSet = exports.ReadonlySet = exports.ValidReadonlyDate = exports.ReadonlyDate = exports.ReadonlyURL = exports.ReadonlyURLSearchParams = void 0;
exports.ReadonlyURLSearchParams = (init) => new URLSearchParams(init);
exports.ReadonlyURL = (url, base) => {
    try {
        return new URL(url, base);
    }
    catch {
        return undefined;
    }
};
exports.ReadonlyDate = (value) => new Date(value);
exports.ValidReadonlyDate = (value) => {
    const d = new Date(value);
    return isNaN(d.getMilliseconds()) ? undefined : d;
};
exports.ReadonlySet = (values) => new Set(values);
// eslint-disable-next-line @typescript-eslint/ban-types
exports.ReadonlyWeakSet = (values) => new WeakSet(values);
exports.ReadonlyMap = (values) => new Map(values);
// eslint-disable-next-line @typescript-eslint/ban-types
exports.ReadonlyWeakMap = (values) => new WeakMap(values);
